import { Component, OnInit } from '@angular/core';
import {MatDialog} from "@angular/material/dialog";
import {TaskgroupCreationComponent} from "../taskgroup-creation/taskgroup-creation.component";
import {TaskgroupEntityInfo, TaskgroupService} from "../../../api";
import {TaskgroupDeletionComponent} from "../taskgroup-deletion/taskgroup-deletion.component";

@Component({
  selector: 'app-taskgroup-dashboard',
  templateUrl: './taskgroup-dashboard.component.html',
  styleUrls: ['./taskgroup-dashboard.component.css']
})
export class TaskgroupDashboardComponent implements OnInit {

  constructor(private dialog: MatDialog,
              private taskgroupService: TaskgroupService) { }

  taskgroups: TaskgroupEntityInfo[] = []

  ngOnInit(): void {
    this.taskgroupService.taskgroupsGet().subscribe({
      next: resp => {
        this.taskgroups = resp;
      }
    })
  }

  openTaskgroupCreation() {
    const dialogRef = this.dialog.open(TaskgroupCreationComponent, {minWidth: "400px"})
    dialogRef.afterClosed().subscribe(res => {
      if(res != undefined) {
        this.taskgroups.push(res);
      }
    })
  }

  openTaskgroupEditor(taskgroup: TaskgroupEntityInfo) {
    const dialogRef = this.dialog.open(TaskgroupCreationComponent, {data: taskgroup, minWidth: "400px"});
    dialogRef.afterClosed().subscribe(res => {
      if(res) {
        const data = this.taskgroups
      }
    })
  }

  openTaskgroupDeletion(taskgroup: TaskgroupEntityInfo) {
    const dialogRef = this.dialog.open(TaskgroupDeletionComponent, {data: taskgroup, minWidth: "400px"});
    dialogRef.afterClosed().subscribe(res => {
      if(res) {
       this.taskgroups = this.taskgroups.filter(ctg => ctg.taskgroupID != taskgroup.taskgroupID)
      }
    })
  }
}
